<template>
     <div class="timer-app">
        <div class="app-header">
            <div class="top-app">
                <router-link to="/timer">
                    <span class="icon-close"></span>
                </router-link>
                <h1 class="title">Search issues</h1>
                <span></span>
            </div>
            <div class="timer-container">
                <div class="top">
                    <div class="top-wrapper">
                      <v-select :on-search="getProjects" :on-change="projectChange" class="projets" :style="{margin: '5px 0', width: '100%'}" placeholder="Projects..." :options="projects"></v-select>
                      <div class="filters">
                        <v-select :on-search="getTypes" :on-change="typeChange" class="projets" :style="{margin: '0 5px 0 0', width: '50%', display: 'inline-block' }" placeholder="Type..." :options="types"></v-select>
                        <v-select :on-search="getStatuses" :on-change="statusChange" class="projets"  :style="{width: '47%', display: 'inline-block'}"  placeholder="Status..." :options="statuses"></v-select>
                       </div>
                       <div class="advanced-options">
                           <span v-on:click="showAdvancedPanel">Advanced</span>
                       </div>
                    </div>
                </div>
            </div>
        </div>
        <!--tasks-->
        <div class="app-tasks-search">
            <div v-bind:class="[this.showAdvanced?'active-advanced':'', 'advanced-panel']" class="advanced-panel">
                <v-select :on-change="usersChange" :on-search="getUsers" class="projets" :style="{'margin-bottom': '5px', width: '90%'}" placeholder="Assignee..." :value.sync="userSelected" :options="users"></v-select>
            </div>
            <div class="task-grid-search">
                <img v-if="this.loading" class="loading" src="assets/loading.svg" alt="">
                    <div  v-for="(task,index) in tasks" v-bind:key="index" class="task-item">
                        <div class="task-container">
                            <div class="item-container">
                                <div class="col-icon">
                                   <img v-bind:src="task.icon"/>
                                </div>
                                <div class="col-desc">
                                    <h3 class="task-id">{{ task.key }}</h3>
                                    <h2 class="task-name">{{ formatText(task.summary,60)}}</h2>
                                    <h2 class="task-name">Status: {{task.status}}</h2>
                                </div>
                                <div class="col-actions">
                                    <div class="controls">
                                        <span v-on:click="openIssue(task.key)" class="icon-settings start-task"></span>
                                        <span v-on:click="loadInTimer(task)" class="icon-play start-task"></span>
                                    </div>
                                    <span class="current-time"></span>
                                </div>
                             </div>
                        </div>
                    </div>
            </div>
        </div>
        <div class="app-footer">
          <span class=""></span>
          <label  class="time-elapsed"></label>
        </div>
        {{ hasTimer }}
    </div>
</template>

<script>
    const {ipcRenderer} = window.require('electron')
    import vSelect from "vue-select"
    export default {
      components: {vSelect},
      name: 'search-page',
      data: function () {
        return {
            isCreated: false,
            showAdvanced: false,
            timerId: 0,
            projects: [],
            users: [],
            types: [],
            statuses: [],
            selected: null,
            projectSelected: null,
            userSelected: null,
            typeSelected: null,
            statusSelected: null,
            tasks: [],
            task: { key:'', summary:'', link: '', icon: '', status: ''},
            loading: false
        }
      },
      computed: {
        hasTimer () {
           this.timerId = this.$store.state.counters.init.id;
           this.$store.commit('CLEAR_INIT')
        }
      },
      methods: {
        // format method, remove text to fit the size of cutAt parameter and add ... at the end
        formatText: function (text,cutAt){
            return text.substr(0,cutAt-1)+(text.length>cutAt?'...':'');
        },
        showAdvancedPanel: function() {
          this.showAdvanced = this.showAdvanced !== true;
        },
        getProjects: function(search){
           ipcRenderer.send('get-projects',search)
        },
        getTypes: function(search){
           ipcRenderer.send('get-types',search)
        },
        getStatuses: function(search){
           ipcRenderer.send('get-statuses',search)
        },
        getUsers: function(search){
           ipcRenderer.send('get-users',search)
        },
        listFormat: function(list,type){
            if(type === 'project')
                return  list.map(function(obj){  return {'label': obj.name,'value': obj.key}; });
            
            if(type === 'user')
                return list.map(function(obj){  return {'label': obj.displayName,'value': obj.name};  });

            if(type === 'type' || type === 'status')
                return list.map(function(obj){   return  {'label': obj.name,'value': obj.name}; });
        },
        projectChange: function(val) {
          this.projectSelected = val
          this.loading = true
          ipcRenderer.send('search-issues', {project: this.projectSelected, type: this.typeSelected, status: this.statusSelected, user: this.userSelected})
        },
        usersChange: function (val) {
          this.userSelected = val
          this.loading = true
          ipcRenderer.send('search-issues', {project: this.projectSelected, type: this.typeSelected, status: this.statusSelected, user: this.userSelected})
        },
        typeChange: function (val) {
          this.typeSelected = val
          this.loading = true
          ipcRenderer.send('search-issues', {project: this.projectSelected, type: this.typeSelected, status: this.statusSelected, user: this.userSelected})
        },
        statusChange:function (val) {
          this.statusSelected = val
          this.loading = true
          ipcRenderer.send('search-issues', {project: this.projectSelected, type: this.typeSelected, status: this.statusSelected, user: this.userSelected})
        },
        openIssue: function (key) {
          ipcRenderer.send('open-issue', key)
        },
        loadInTimer:function (task) {
          this.$store.commit('LOAD_VALUE', {key: task.key, id: this.timerId})
          this.changeStatus(task)
          this.$router.push('timer')
        },
        changeStatus:function(task) {
          if(task.status == 'To Do' || task.status == 'Por Hacer')
            ipcRenderer.send('change-issue-status',task.key)
        }
      },
      activated: function(){
          let windowHeiht = $(window).height()
          $('.app-tasks-search').height(windowHeiht - 150)
          $('.task-grid-search').height(windowHeiht - 150)
      },
      created: function () {
        this. loading = true
        ipcRenderer.send('initialize-search')
       
        ipcRenderer.on('initialize-search-success', (event, arg) => {
          this.projects = this.listFormat(arg.projects,'project')
          this.users = this.listFormat(arg.users,'user')
          this.types = this.listFormat(arg.types,'type')
          this.statuses = this.listFormat(arg.statuses,'status')
          this.userSelected = {label: arg.currentUser.displayName, value:arg.currentUser.name} 
          ipcRenderer.send('search-issues', {project: this.projectSelected, type: this.typeSelected, status: this.statusSelected, user: this.userSelected})
        })
        ipcRenderer.on('initialize-search-failed', (event, arg) => {
           console.log(arg)
        })
        ipcRenderer.on('get-projects-success', (event, arg) => {
            this.projects = this.listFormat(arg,'project')
        })
        ipcRenderer.on('get-users-success', (event, arg) => {
            this.users = this.listFormat(arg,'user')
        })
        ipcRenderer.on('get-statuses-success', (event, arg) => {
            this.statuses = this.listFormat(arg,'status')
        })
        ipcRenderer.on('get-types-success', (event, arg) => {
            this.types = this.listFormat(arg,'type')
        })
        ipcRenderer.on('success-search', (event, arg) => {
          this.tasks = [];
          let self = this
          this.loading = false;
          arg.issues.forEach(function(issue) {
             let tempTask = {key: issue.key, summary: issue.fields.summary, link: issue.self, icon: issue.fields.issuetype.iconUrl, status: issue.fields.status.name}  
             self.tasks.push(tempTask)
          });
          this.isCreated = true;
        })
        ipcRenderer.on('failed-search', (event, arg) => {
          this.loading = false;
          console.log(arg)
        })
  
      }
    }
</script>


<style scoped lang="scss">
    @import url('https://fonts.googleapis.com/css?family=Roboto');

    //Imports
    $red-color: #ef5f59;
    $roboto: 'Roboto', sans-serif;

    textarea:focus, input:focus{
        outline: none;
    }
    .without::-webkit-datetime-edit-ampm-field {
        display: none;
    }

    .active-advanced{
        top:0!important;
    }

    .active-message{
        bottom:0 !important;
        transition: linear .5s;
    }

    .active-task{
        bottom:50px !important;
        transition: linear .5s;
    }

    .text{
        font-family: $roboto;
        font-size: 16px;
        color:#888;
    }
    .regular{
        font-family: $roboto;
        font-size: 14px;
        color:#888;
        margin:0;
    }
    .small{
        font-family: $roboto;
        font-size: 12px;
        color:#888;
        margin:0;
    }
    .timer-app {
        width: 100%;
        height: 100vh;
        background: $red-color;
        color: white;
        overflow-y: hidden;
    }
    .app-header{
        height:160px;
        position: relative;
        z-index: 400;
        .top-app{
            width: 100%;
            height: 50px;
            line-height: 50px;
            text-align: center;
            box-shadow: 0 2px 5px -1px rgba(80, 79, 79, 0.75);
            position:relative;
            display: flex;
            justify-content: space-between;
            align-items: center;
            h1.title{
                font-family: $roboto;
                font-size: 18px;
                font-weight: 500;
                margin: 0;
            }
            span{
                font-size: 22px;
                color:#FFF;
                width: 45px;
                text-align: center;
                display: inline-block;
                &:hover{
                    color:#FEE;
                    cursor: pointer;
                    transition:all .3s;
                }

            }
        }
        .timer-container{
            width: 100%;
            height: 110px;
            text-align: center;
            .top{
              background: lighten(#eee,5%);
              .top-wrapper{
                font-size: 12px;
                width: 90%;
                margin: 0 auto;
                display: flex;
                flex-direction: column;
                align-items: flex-start;
                height: 110px;
                .advanced-options{
                    display: flex;
                    width: 100%;
                    justify-content: flex-end;
                    margin-top: 5px;
                    span{
                        @extend .small;
                        cursor: pointer;
                    }
                }
                .filters{
                    width: 100%;
                    display: block;
                }
              }
            }
            
            .current-task{
                position: relative;
                height: 50px;
                color: #FFF;
                h2{
                    margin: 0;
                    padding: 0;
                    line-height: 20px;
                    font-size: 16px;
                }
                img{
                    position: absolute;
                    height: 20px;
                    top: -20px;
                    left: 183px;
                }
            }
        }
    }
    .info-messages{
        width: 100%;
        height: 25px;
        position: absolute;
        bottom:-26px;
        background: lighten(#eee,5%);
        border-bottom: 1px solid #eee;
        text-align: center;
        transition:all .5s;
        p{
            line-height: 25px;
            @extend .regular;

        }

    }
    .app-tasks-search {
        width: 100%;
        height: 100%;
        min-height: 300px;
        background: white;
        position: relative;
        .advanced-panel{
            display: flex;
            justify-content: center;
            background: lighten(#eee,5%);
            position: absolute;
            width: 100%;
            height: 45px;
            top:-45px;
            z-index: 200;
            transition: all .2s;
            font-size: 12px;
        }
        .task-grid-search {
            position: relative;
            overflow-y: scroll;
            overflow-x: hidden;
            height: 250px;
            &::-webkit-scrollbar-track {

                background-color: #FFF;
            }

            &::-webkit-scrollbar {
                width: 8px;
                background-color: #F5F5F5;
            }

            &::-webkit-scrollbar-thumb {

                background-color: lighten(#ddd,10%);
            }
            .loading{
                position: absolute;
                top: 15px;
                right: 170px;
            }
            .task-item{
                width: 100%;
                height: 75px;
                overflow: hidden;
                position: relative;
                .task-container{
                    position: absolute;
                    top: 0;
                    width: 100%;
                    height: 75px;
                    transition: all .5s;
                    .item-container{
                        display: flex;
                        align-items: center;
                        width: 100%;
                        height: 75px;
                        padding: 0 5px;
                        border-bottom:1px solid rgba(#DDD,.5%);
                        .col-icon{
                            width: 10%;
                            display: flex;
                            justify-content: center;
                        }
                        .col-desc{
                            width: 70%;
                            h3.task-id{
                                @extend .regular;
                            }
                            h2.task-name{
                                @extend .regular;
                            }
                        }
                        .col-actions{
                            width: 20%;
                            display: flex;
                            flex-direction: column;
                            align-items: center;
                            span.current-time{
                                @extend .small;
                            }
                            span.start-task{
                                color:#888;
                                cursor: pointer;
                            }
                        }
                        .col-left-edit{
                            width: 55%;
                            h3.task-id{
                                @extend .regular;
                            }
                            h2.task-name{
                                @extend .regular;
                            }

                        }
                        .col-right-edit{
                            width: 40%;
                            display: flex;
                            flex-direction: row;
                            justify-content: space-around;
                            align-items: center;
                            div{
                                border: 1px solid #d4cdcd;
                                border-radius: 5px;
                                width: 60%;
                                text-align: center;
                            }
                            input{
                                width:40%;
                                text-align: center;
                                height: 25px;
                                border:none;
                            }
                            span.separator{
                                color: #888;
                            }
                            span.start-task{
                                color:#888;
                                cursor: pointer;
                            }
                        }
                    }
                }

            }

        }
    }
    .app-footer{
        width: 100%;
        height: 0px;
        background: lighten(#eee,5%);
        position: fixed;
        bottom: 0;
        display: flex;
        align-items: center;
        color: black;
        justify-content: space-between;
        font-size: 14px;
        line-height: 50px;
        .entry{
            width: 70px;
            height: 35px;
            @extend .text;
            display: flex;
            align-items: center;
            justify-content: center;
            transition:all .3s;
            &:hover{
                color:lighten(#888,10%);
                cursor: pointer;
                transition:all .3s;
            }


            &::before{
                font-family: "timer";
                font-size: 18px;
                color:#888;
                display: inline-block;

                position: relative;
                top: 2px;
                left: -1px;
            }
        }
        .time-elapsed{
            @extend .text;
            min-width: 100px;
            text-align: center;
        }
    }

    .app-new-task{
        width: 100%;
        height: 50px;
        display: flex;
        background: lighten(#eee,5%);
        position: absolute;
        bottom: 0;
        align-items: center;
        color: black;
        justify-content: space-around;
        font-size: 14px;
        line-height: 50px;
        transition:all .5s;

        .entry{
            width: 60%;
            height: 35px;
            @extend .text;
            display: flex;
            align-items: center;
            justify-content: center;
            transition:all .3s;
            text-indent:5px;
            border: 1px solid lightgray;
            border-radius: 40px;
            &:hover{
                color:lighten(#888,10%);
                transition:all .3s;
            }
            &::before{
                font-family: "timer";
                font-size: 18px;
                color:#888;
                display: inline-block;

                position: relative;
                top: 2px;
                left: -1px;
            }
        }
        .time-elapsed{
            @extend .text;
            min-width: 100px;
            text-align: center;
        }
        .entryLabel{
            max-width: 100px;
            width: 40%;
            position: relative;
            left: -60px;
            @extend .text;
        }
    }
</style>
